<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>{{ title }}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="refresh" content="300" /><!-- <meta http-equiv="refresh" content="5" />  每 content 秒網頁自動更新-->

    <!-- 新 Bootstrap4 核心 CSS 文件 -->
    <link rel="stylesheet" href="https://cdn.bootcss.com/bootstrap/4.1.0/css/bootstrap.min.css">
    <!-- jQuery文件。务必在bootstrap.min.js 之前引入 -->
    <script src="https://cdn.bootcss.com/jquery/3.2.1/jquery.min.js"></script>
    <!-- popper.min.js 用于弹窗、提示、下拉菜单 -->
    <script src="https://cdn.bootcss.com/popper.js/1.12.5/umd/popper.min.js"></script>
    <!-- 最新的 Bootstrap4 核心 JavaScript 文件 -->
    <script src="https://cdn.bootcss.com/bootstrap/4.1.0/js/bootstrap.min.js"></script>
    <!--可用來建立使用者小圖示-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script language="JavaScript">
        // 指定 秒 刷新網頁一次
        var dtn = '{{tid}}';
        var status = '{{status}}';
        console.log('dtn:' + dtn)

        $(function(){
            $("#dry_output_page").text('乾燥貨櫃出料儲豆槽 DO' + dtn + ' 攝影機畫面   ')
            $('#dry_output_page').attr("href", "/camera_DO" + dtn)
            $("#dry_container_output_title").text('乾燥貨櫃出料儲豆槽 DO' + dtn + ' 操作介面')
            $("#coffee_title").text('DO' + dtn + ' 乾燥出料儲豆槽操作介面');
            if (status == 2) {
                $('input').prop('disabled', true);
                $('button').prop('disabled', true);
            } else if ( (status == 0) || (status == 1) ) {
                $('input').prop('disabled', false);
                $('button').prop('disabled', false);   
            }
        });

        WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000)
    </script>

    <style>
        .footer{
            position: absolute;
            width: 100%;
            background-color: #eee;
            text-align: center;
        }

        body {
            margin: 0;
        }

        .navbar-dark .navbar-nav .nav-link {
            color: white;
            cursor: pointer;
            text-decoration: none;
            width: 110px;
            height: 46px;
        }

        .nav-top {
            line-height: 40px;
            background-color: #C4C4C4;
        }

        .website_title {
            font-family: Roboto;
            font-style: normal;
            font-weight: normal;
            font-size: 30px;
            color: #000000;
        }

        .navbar-nav>li {
            float: none;
            display: inline-block;
            width: 100px;
            margin: 0 auto;
            text-align: center;
        }

        .navbar-nav>li a {
            font-size: 20px;
        }

        .main-page {
            margin-top: 200px;
        }

        .page-title {
            font-family: Roboto;
            font-style: normal;
            font-weight: bold;
            font-size: 36px;
        }


        .flex {
            display: flex;
            flex-direction: row;
            flex-wrap: wrap;
            justify-content: center;
        }

        .set-link {
            display: inline-block;
            width: 350px;
            height: 100px;
            line-height: 100px;
            background: #008CBA;
            border: 1px solid #CFCFCF;
            box-sizing: border-box;
            color: #FFFFFF;
            border-radius: 10px;
            font-size: 36px;
        }

        .cmn-toggle {
            position: absolute;
            margin-left: 0px;
            visibility: hidden;
        }

        .cmn-toggle+label {
            display: block;
            position: relative;
            cursor: pointer;
            outline: none;
            user-select: none;
        }

        input.cmn-toggle-round-flat+label {
            padding: 2px;
            width: 60px;
            height: 30px;
            background-color: #C0C0C0;
            border-radius: 60px;
            transition: background 0.4s;
        }

        input.cmn-toggle-round-flat+label:before,
        input.cmn-toggle-round-flat+label:after {
            display: block;
            position: absolute;
            content: "";
        }

        input.cmn-toggle-round-flat+label:before {
            top: 2px;
            left: 2px;
            bottom: 2px;
            right: 2px;
            background-color: #fff;
            border-radius: 60px;
            transition: background 0.4s;
        }

        input.cmn-toggle-round-flat+label:after {
            top: 4px;
            left: 4px;
            bottom: 4px;
            width: 24px;
            background-color: #dddddd;
            border-radius: 52px;
            transition: margin 0.4s, background 0.4s;
        }

        input.cmn-toggle-round-flat:checked+label {
            background-color: #C0C0C0;
        }

        input.cmn-toggle-round-flat:checked+label:after {
            margin-left: 27px;
            background-color: #008CBA;
        }

        @media(max-width:373px) {
            .card {
                margin-right: 0px;
            }

            .set-link {
                width: 250px;
            }
        }

        @media(max-width:577px) {}

        @media(min-width:576px) {}

        @media(min-width:768px) {
            .navbar-nav>li {
                margin-left: 0px;
            }

            .navbar-nav .li-block {
                display: none;
            }
        }

        @media(min-width:991px) {
            .navbar-nav>li {
                margin-left: 20px;
            }

            .navbar-nav .li-block {
                display: none;
            }
        }

        @media(min-width:1200px) {
            .navbar-nav>li {
                margin-left: 50px;
            }

            .navbar-nav .li-block {
                display: inline-block;
                width: 100px;
            }
        }

        @media(min-width:1400px) {
            .navbar-nav .li-block {
                display: inline-block;
                width: 200px;
            }
        }


        @media(min-width:1689px) {
            .navbar-nav>li {
                margin-left: 50px;
            }

            .navbar-nav .li-block {
                display: inline-block;
                width: 500px;
            }
        }
    </style>
    <script>
        // Rita 制動器運作

        var tank_num = '{{tid}}';

        function outputVacuum() {
            var status = "off";
            var check = $("input[name=output_vacuum_status]:checked");
            //大於0代表有被選中
            if (check.length > 0) {
                status = "on";
                $("#cmn-toggle-32").prop('checked', false);
                if (!confirm("你確定要開啟出料儲豆槽真空吸料機嗎?")) {
                    return false;
                };

            } else {
                $("#cmn-toggle-32").prop('checked', true);
                if (!confirm("你確定要關閉出料儲豆槽真空吸料機嗎?")) {
                    return false;
                };
            };

            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": status };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                    setTimeout("alert('出料儲豆槽真空吸料機_開啟成功!')", 500);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                    setTimeout("alert('出料儲豆槽真空吸料機_關閉成功!')", 500);
                } else {
                    alert(res);
                };
            }, 'text')
        };
        function outputVacuum_ON() {
            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": "on" };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                } else {
                    console.log('res error')
                };
            }, 'text')
        }
        function outputVacuum_OFF() {
            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": "off" };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                } else {
                    console.log('res error')
                };
            }, 'text')
        }
    </script>
</head>

<body>
    <div id="wrapper">
        <div id="coffee_header">
            <!-- 匯入共同使用的 header.html 內容 -->
            {% include 'header.html' %}
        </div>
        <!--
        <div style="text-align: left;">
            <a href="/dry" style="float: left;">&nbsp;&nbsp;&nbsp;返回乾燥貨櫃首頁</a>
        </div>
        <div style="text-align: right;">
            <a id="dry_output_page" href="/index_new" style="float: right;">___________________</a>
        </div>
        <div id="dry_container_output_title" style="text-align: center; margin-top: 30px; font-size: 24px; margin-bottom: 15px;">
            乾燥貨櫃出料儲豆槽 DO 操作介面
        </div>
        -->

        狀態更新時間(秒)：
        <input name="webupdate_time" type="text" value="5" style="width: 40px;">
        <input type="button" value="設定更新時間" onclick="changeUpdate()">

        <script language="JavaScript">
            
            function changeUpdate() {
                clearInterval(WebUpdate_set);

                var webupdate_time = $("input[name=webupdate_time]").val()
                console.log('webupdate_time' + webupdate_time)
                WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , webupdate_time * 1000);
            }

            // jQuery 更新感測器制動器狀態
            function WebUpdate(dtn) {
                
                $.get('/loading/DO' + dtn, '', function (res) {
                    if (res.output_vacuum == 0) {
                        $("#output_vacuum_status").css("background-color", "#C0C0C0")
                    } else if (res.output_vacuum == 1) {
                        $("#output_vacuum_status").css("background-color", "forestgreen")
                    } else { $("#output_vacuum_status").css("background-color", "crimson") }

                    $("#UltraSonic_t_status").text(res.output_UltraSonic);

                }, 'json');
            }
        </script>

        <h4>制動器</h4>    
        <table border="1" style="font-size:18px; border:2px #cccccc solid; margin-left: 2px; margin-right: 2px;" width=98%>
            <tr>
                <td style="color:red;">Valve</td>
                <td>真空吸料機</td>
            </tr>
            <tr>
                <td>
                    <span style="color:#C0C0C0;">off</span>
                    <span style="color:#008CBA;">on</span>
                </td>
                <td>
                    <div class="switch_div">
                        <div class="switch">
                            <input id="cmn-toggle-31" class="cmn-toggle cmn-toggle-round" type="checkbox">
                            <label for="cmn-toggle-31"></label>
                        </div>
                        <div class="switch text-center">
                            {% if output_vacuum == 1 %}
                            <input id="cmn-toggle-32" class="cmn-toggle cmn-toggle-round-flat" type="checkbox" checked
                                name="output_vacuum_status" value="ON" onclick="outputVacuum()">
                            {% else %}
                            <input id="cmn-toggle-32" class="cmn-toggle cmn-toggle-round-flat" type="checkbox"
                                name="output_vacuum_status" value="OFF" onclick="outputVacuum()">
                            {% endif %}
                            <label for="cmn-toggle-32"></label>
                        </div>
                        <div class="switch">
                            <input id="cmn-toggle-33" class="cmn-toggle cmn-toggle-yes-no" type="checkbox">
                            <label for="cmn-toggle-33" data-on="Yes" data-off="No"></label>
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td><span style="color:#008CBA;"><b>ON</b></span></td>
                <td><input type="button" value="ON" onclick="outputVacuum_ON()"></td>
            </tr>
            <tr>
                <td><span style="color:#C0C0C0;"><b>OFF</b></span></td>
                <td><input type="button" value="OFF" onclick="outputVacuum_OFF()"></td>
            </tr>
        </table>

        <br>

        <h4>感測器</h4>
        <table border="1" style="font-size:18px; border:2px #cccccc solid; margin-left: 2px; margin-right: 2px;" cellpadding="10" width=98%>
            <tr>
                <td>[出料儲豆槽] 生豆高度：<span id="UltraSonic_t_status">{{output_UltraSonic.UltraSonic}}</span> 公分</td>
            </tr>
        </table>

        <br>

        <h4>排程設計</h4>
        <table border="1" style="font-size:18px; border:2px #cccccc solid; margin-left: 2px; margin-right: 2px;" width=98%>
            <tr>
                <td>入料</td>
                <td>循環測試</td>
            </tr>
            <tr>
                <td>
                    指定桶內生豆高度
                    <input name="testing_BeanIn_Height" type="text" value="0" style="width: 40px;">公分<br>
                    吸料時間
                    <input name="testing_in_vacuum_in" type="text" value="1" style="width: 40px;">秒<br>
                    放料時間
                    <input name="testing_in_vacuum_out" type="text" value="10" style="width: 40px;">秒<br>
                    循環次數
                    <input name="testing_in_vacuum_loop" type="text" value="3" style="width: 40px;">次<br>
                </td>
                <td>
                    ON (開) &nbsp;
                    <input name="Testing_starttime" value="3" type="text" style="width: 40px;">秒<br>
                    OFF (關) &nbsp;
                    <input name="Testing_endtime" value="5" type="text" style="width: 40px;">秒<br>
                    循環
                    <input name="Testing_loop" value="3" type="text" style="width: 40px;">次
                </td>
            </tr>
            <tr>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="BeanInput()">入料測試</button>
                    <script>
                        var BeanIn_Process = 0;
                        var BeanIn_interval;
                        function BeanInput() {
                            clearInterval(WebUpdate_set);
                            var testing_BeanIn_Height = $("input[name=testing_BeanIn_Height]").val();
                            var testing_in_vacuum_in = $("input[name=testing_in_vacuum_in]").val();
                            var testing_in_vacuum_out = $("input[name=testing_in_vacuum_out]").val();
                            var testing_in_vacuum_loop = $("input[name=testing_in_vacuum_loop]").val();

                            if (testing_BeanIn_Height != 0) {
                                console.log('以指定高度入豆')
                                var BeanIn_interval = setInterval(BeanInHeight, 5000);

                                function BeanInHeight(){
                                    if (BeanIn_Process == 1) {
                                        return;
                                    }

                                    BeanIn_Process == 1;
                                    $.ajax({
                                        async:false,
                                        type:"GET",
                                        url:"/dry_UltraSonic_" + tank_num,
                                        dataType:"json",
                                        success:function(response){
                                            var present_Bean_height = response.UltraSonic
                                            console.log('目前生豆高度: ' + present_Bean_height)

                                            if ( parseInt(present_Bean_height) < parseInt(testing_BeanIn_Height) ) {
                                                outputVacuum_ON()
                                                console.log('outputVacuum_ON')
                                                
                                                var time = new Date();
                                                while ((new Date() - time) < testing_in_vacuum_in * 1000) { };

                                                outputVacuum_OFF()
                                                console.log('outputVacuum_OFF')

                                                var time = new Date();
                                                while ((new Date() - time) < testing_in_vacuum_out * 1000) { };
                                            } else {
                                                clearInterval(BeanIn_interval)
                                                console.log('生豆已達指定高度！')
                                            }
                                            BeanIn_Process == 0;
                                        },
                                        error:function(thrownError){
                                            console.log('Error: ' + thrownError)
                                            BeanIn_Process = 0;
                                        }
                                    })
                                };

                            } else if (testing_BeanIn_Height == 0) {
                                console.log('以循環次數入豆')

                                for (step = 1; step <= testing_in_vacuum_loop; step++) {
                                    console.log('-- 循環第 ' + step + ' 次 --');

                                    outputVacuum_ON()
                                    console.log('outputVacuum_ON')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_in_vacuum_in * 1000) { };

                                    outputVacuum_OFF()
                                    console.log('outputVacuum_OFF')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_in_vacuum_out * 1000) { };
                                }

                                console.log('循環入豆結束')
                            }
                            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000);
                        }
                    </script>
                </td>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="tankVacuumTest()">真空吸料機測試(秒)</button><br>
                    <script>
                        function tankVacuumTest() {
                            clearInterval(WebUpdate_set);
                            var Testing_starttime = $("input[name=Testing_starttime]").val();
                            var Testing_endtime = $("input[name=Testing_endtime]").val();
                            var Testing_loop = $("input[name=Testing_loop]").val();
                            alert('測試間隔' + Testing_starttime + ':' + Testing_endtime + ' 次數' + Testing_loop)
                            var step;

                            for (step = 1; step <= Testing_loop; step++) {
                                console.log('循環第 ' + step + ' 次');

                                outputVacuum_ON()
                                console.log('outputVacuum_ON')

                                var time = new Date();
                                while ((new Date() - time) < Testing_starttime * 1000) { }

                                outputVacuum_OFF()
                                console.log('outputVacuum_OFF')

                                var time = new Date();
                                while ((new Date() - time) < Testing_endtime * 1000) { }
                            }
                            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000);
                        }
                    </script>
                </td>
            </tr>
        </table>

        <br>

        <h4>M5 攝影機畫面</h4>
        <div class="container-fluid">
            <div class="row" style="margin-top:10px;">
                <div class="col flex">
                    <div class="col-md-12 row flex" style="text-align:center;margin-top:5px;">
                        <div class="col-md-12 row flex">
                            <img src="" id="four" width="70%" height="70%">
                        </div>
                    </div>
                    <script>
                        // M5 攝影機

                        //const img = document.querySelector('#one');
                        const img3 = document.querySelector('#four');
                        const WS_URL3 = 'ws:///60.250.156.230:8093';
                        //const WS_URL3 = 'ws:///60.250.156.230:8091';
                        const ws3 = new WebSocket(WS_URL3);
                        let urlObject3;
                        ws3.onopen = () => console.log(`Connected to ${WS_URL3}`);
                        ws3.onmessage = message3 => {
                            const arrayBuffer3 = message3.data;
                            if (urlObject3) {
                                URL.revokeObjectURL(urlObject3);
                            }
                            urlObject3 = URL.createObjectURL(new Blob([arrayBuffer3]));
                            img3.src = urlObject3;
                        }
                    </script>
                </div>
            </div>
        </div>
        

        <br>
        <br>
<!--
        <footer class="footer">
            <div style="text-align: center; margin-top: 10px; font-size: 13px; margin-bottom: 10px;">
                Copyright © 2021 Gold-in Tech. All Rights Reserved. 金子進科技股份有限公司 版權所有
                <a href="mailto:service.gitc@gmail.com" target="_blank">service.gitc@gmail.com</a>
            </div>
        </footer>
-->
        <div id="coffee_footer">
            <!-- 匯入共同使用的 footer.html 內容 -->
            {% include 'footer.html' %}
        </div>
    </div>

</body>

</html>